<template>
  <div class="hello">
    <h3 ref="title">
      {{ title }}
      <slot :fullName="fullName">-</slot>
    </h3>
    <p v-text="text"></p>
    <p :title="name + ' ' + surname">Автор: {{ fullName }}</p>
    
    <slot name="image"></slot>
    
    <button @click="toggleView">
      <template v-if="viewModeFull">Скрыть</template>
      <template v-else>Раскрыть</template>
    </button>
  </div>
</template>

<script>
export default {
  name: 'HelloWorld',
  props: {
    title: String,
    content: String,
    name: String,
    surname: {
      type: String,
      default: 'Смирнов'
    },
  },
  data() {
    return {
      viewModeFull: false
    }
  },
  computed: {
    fullName() {
      return `${this.name[0]} ${this.surname}`
    },
    text() {
      return this.viewModeFull ? this.content : this.content.slice(0, 300) + '...'
    },
  },
  methods: {
    toggleView() {
      this.viewModeFull = !this.viewModeFull
      
      if (this.viewModeFull) {
        this.$emit('expand')
      } else {
        this.$emit('rollUp')
      }
    },
  }
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
h3 {
  margin: 40px 0 0;
}
ul {
  list-style-type: none;
  padding: 0;
}
li {
  display: inline-block;
  margin: 0 10px;
}
a {
  color: #42b983;
}
</style>
